﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinCalcManager.FormulaBuilder;
using Infragistics.Win.CalcEngine;
using Infragistics.Win.UltraWinCalcManager;

namespace UltraGirdSummaryGroupBy
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            MyCustomFunction fff = new MyCustomFunction();
            ultraCalcManager1.RegisterUserDefinedFunction(fff);
            ShowFormulaBuilderDialog(ultraGrid1.DisplayLayout.Bands[0].Columns["UC"] as IFormulaProvider);
        }

        private void ShowFormulaBuilderDialog(IFormulaProvider formulaProvider)
        {
            //FormulaBuilderDialog formulaBuilderDialog = new FormulaBuilderDialog(formulaProvider);
            AliasFormulaBuilderDialog formulaBuilderDialog = new AliasFormulaBuilderDialog(formulaProvider);
            formulaBuilderDialog.AliasLookup.Add("ultraGrid1", "Grid");
            formulaBuilderDialog.AliasLookup.Add("Band 0", "Main Band");
            formulaBuilderDialog.AliasLookup.Add("Desc", "Alias Description");
            formulaBuilderDialog.AliasLookup.Add("Value", "Alias Value");
            formulaBuilderDialog.AliasLookup.Add("Item", "Alias Item");
            //formulaBuilderDialog.OperandInitializing += new OperandInitializingEventHandler(formulaBuilderDialog_OperandInitializing);

            formulaBuilderDialog.ShowDialog(this);
            formulaProvider.Formula = formulaBuilderDialog.Formula;
        }


        void formulaBuilderDialog_OperandInitializing(object sender, OperandInitializingEventArgs e)
        {
            //e.Cancel = true;
            //switch (e.OperandName)
            //{
            //    case "ultraGrid1":
            //        e.OperandAlias = "Grid";
            //        break;
            //    case "Band 0":
            //        e.OperandAlias = "Main Band";
            //        break;
            //    case "Desc":
            //        e.OperandAlias = "Alias Description";
            //        break;
            //    case "Value":
            //        e.OperandAlias = "Alias Value";
            //        break;
            //    case "Item":
            //        e.OperandAlias = "Alias Item";
            //        break;
            //    default:
            //        e.OperandAlias = e.OperandName;
            //        break;
            //}
        }
    }


    public class MyCustomFunction : Infragistics.Win.CalcEngine.UltraCalcFunction
    {
        public MyCustomFunction()
        {
        }

        private string[] argDescriptors = new string[] { "Test argDescription 1", "Test argDescription 2" };
        public override string[] ArgDescriptors
        {
            get { return argDescriptors; }
        }

        private string[] argList = new string[] { "Here is my first Agrument", "Here is my second Agrument" };
        public override string[] ArgList
        {
            get { return argList; }
        }

        public override string Category
        {
            get { return "My Custom Function Category"; }
        }

        public override string Description
        {
            get { return "Here is my description....."; }
        }

        protected override Infragistics.Win.CalcEngine.UltraCalcValue Evaluate(Infragistics.Win.CalcEngine.UltraCalcNumberStack numberStack, int argumentCount)
        {
            // Just replace the content with value "This is the new value from my fuction"
            Infragistics.Win.CalcEngine.UltraCalcValue retVAL = new Infragistics.Win.CalcEngine.UltraCalcValue("This is the new value from my fuction");
            return retVAL;
        }

        public override int MaxArgs
        {
            get { return 2; }
        }

        public override int MinArgs
        {
            get { return 2; }
        }

        public override string Name
        {
            get { return "MyCustomFunctionName"; }
        }
    }
}
